> ## Documentation Index
> Fetch the complete documentation index at: https://www.cashfree.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Beneficiary Details

> Retrieves details of an existing beneficiary of user in the PPI system.
- If `bene_instrument_id` is provided, the response includes details for the specified instrument only.
- If `bene_instrument_id` is not provided, the response includes details for all `bene_instruments` linked to the given `bene_id`.




## OpenAPI

````yaml openapi/ppi/ppi.yaml post /ppi/user/bene/details
openapi: 3.0.3
info:
  title: PPI Wallet API
  description: >-
    API for managing PPI (Prepaid Payment Instrument) wallets and sub-wallets,
    including credit and debit operations.
  version: 1.0.0
  contact:
    name: PPI Service Team
    email: support@cashfree.com
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0
servers:
  - url: https://api.cashfree.com
    description: Production server.
  - url: https://sandbox.cashfree.com
    description: Sandbox server.
security:
  - XClientID: []
    XClientSecret: []
tags:
  - name: Users
    description: Operations related to PPI users.
  - name: User KYC
    description: Operations related to user KYC verification.
  - name: Wallets
    description: Operations related to PPI wallets.
  - name: Beneficiaries
    description: Operations related to user beneficiaries.
  - name: Transfers
    description: Operations related to transfers.
paths:
  /ppi/user/bene/details:
    post:
      tags:
        - Beneficiaries
      summary: Get Beneficiary Details
      description: >
        Retrieves details of an existing beneficiary of user in the PPI system.

        - If `bene_instrument_id` is provided, the response includes details for
        the specified instrument only.

        - If `bene_instrument_id` is not provided, the response includes details
        for all `bene_instruments` linked to the given `bene_id`.
      operationId: getPPIBeneficiary
      parameters:
        - $ref: '#/components/parameters/global_x_api_version'
      requestBody:
        description: Request parameters to fetch beneficiary details for a user.
        required: true
        content:
          application/json:
            schema:
              type: object
              required:
                - user_id
                - bene_id
              properties:
                user_id:
                  type: string
                  description: >-
                    Unique identifier for the user, as provided by you during
                    PPI user creation.
                  example: USER827364
                  minLength: 1
                  maxLength: 50
                bene_id:
                  type: string
                  minLength: 1
                  maxLength: 50
                  description: >-
                    Unique identifier for the beneficiary, as provided by you
                    during beneficiary creation.
                  example: BENE28448
                bene_instrument_id:
                  type: string
                  minLength: 1
                  maxLength: 50
                  description: >-
                    Unique identifier for the instrument, as provided by you
                    during beneficiary creation. If not provided, all
                    `bene_instruments` for the beneficiary will be returned.
                  example: INST194947
            examples:
              withInstrumentId:
                summary: Request with a specific instrument ID
                value:
                  user_id: USER827364
                  bene_id: BENE28448
                  bene_instrument_id: INST194947
              withoutInstrumentId:
                summary: Request without instrument ID to get all `bene_instruments`
                value:
                  user_id: USER827364
                  bene_id: BENE28448
      responses:
        '200':
          description: Success response for fetching beneficiary details.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateBeneResponse'
              examples:
                SUCCESS_WITH_INSTRUMENT_ID:
                  summary: Success response for a specific instrument
                  value:
                    bene_id: BENE28448
                    cf_bene_id: '473974924929'
                    user_id: USER827364
                    bene_first_name: John
                    bene_last_name: Doe
                    status: ACTIVE
                    bene_instruments:
                      - bene_instrument_id: INST194947
                        type: BANK_ACCOUNT
                        bank_bank_account_number: '3749378903'
                        ifsc: HDFC0001234
                        status: ACTIVE
                        verification_status: VERIFIED
                        cf_bene_instrument_id: '8324782642946'
                    bene_contact_details:
                      email: john.doe@example.com
                      phone: '9876543210'
                      dob: '1990-05-12'
                      gender: MALE
                      address: No. 123, 5th Main, Indiranagar
                      city: Bangalore
                      state: Karnataka
                      pincode: '560038'
                      country: India
                    purpose: Family
                    notes:
                      example_key_1: example_value_1
                      example_key_2: example_value_2
                SUCCESS_WITHOUT_INSTRUMENT_ID:
                  summary: Success response for all `bene_instruments`
                  value:
                    bene_id: BENE28448
                    cf_bene_id: '473974924929'
                    user_id: USER827364
                    bene_first_name: John
                    bene_last_name: Doe
                    status: ACTIVE
                    bene_instruments:
                      - bene_instrument_id: INST194947
                        type: BANK_ACCOUNT
                        bank_bank_account_number: '3749378903'
                        ifsc: HDFC0001234
                        status: ACTIVE
                        verification_status: VERIFIED
                        cf_bene_instrument_id: '8324782642946'
                      - bene_instrument_id: INST194948
                        type: VPA
                        vpa: john.doe@upi
                        status: ACTIVE
                        verification_status: VERIFIED
                        cf_bene_instrument_id: '8324782642947'
                    bene_contact_details:
                      email: john.doe@example.com
                      phone: '9876543210'
                      dob: '1990-05-12'
                      gender: MALE
                      address: No. 123, 5th Main, Indiranagar
                      city: Bangalore
                      state: Karnataka
                      pincode: '560038'
                      country: India
                    purpose: Family
                    notes:
                      example_key_1: example_value_1
                      example_key_2: example_value_2
        '400':
          description: Bad request - Invalid input parameters.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StructuredErrorResponse'
              examples:
                userIdMissing:
                  summary: user ID missing
                  value:
                    message: user id is missing
                    code: user_id_missing
                    type: validation_error
                beneIdMissing:
                  summary: beneficiary ID missing
                  value:
                    message: bene id is missing
                    code: bene_id_missing
                    type: validation_error
                userBeneMismatch:
                  summary: User-Beneficiary mismatch
                  value:
                    message: beneficiary does not belong to provided user
                    code: bene_id_value_invalid
                    type: validation_error
                beneInstrumentMismatch:
                  summary: Beneficiary-Instrument mismatch
                  value:
                    message: instrument does not belong to provided beneficiary
                    code: instrument_id_value_invalid
                    type: validation_error
                missingClientId:
                  summary: Missing client ID
                  value:
                    message: x-client-id is missing in the request
                    code: x-client-id_missing
                    type: validation_error
                missingClientSecret:
                  summary: Missing client secret
                  value:
                    message: x-client-secret is missing in the request
                    code: x-client-secret_missing
                    type: validation_error
        '401':
          $ref: '#/components/responses/Response401'
        '403':
          $ref: '#/components/responses/Response403'
        '404':
          description: Not found - Beneficiary or User not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StructuredErrorResponse'
              examples:
                beneNotFound:
                  summary: Beneficiary not found
                  value:
                    code: beneficiary_not_found
                    type: invalid_request_error
                    message: The beneficiary with given id not found
                userNotFound:
                  summary: User not found
                  value:
                    code: user_id_not_found
                    type: invalid_request_error
                    message: The user_id with given id not found
                instrumentNotFound:
                  summary: Instrument not found
                  value:
                    code: instrument_id_not_found
                    type: invalid_request_error
                    message: The bene_instrument_id with given id not found
        '429':
          $ref: '#/components/responses/Response429'
        '500':
          $ref: '#/components/responses/Response500'
      security:
        - XClientID: []
          XClientSecret: []
components:
  parameters:
    global_x_api_version:
      description: API version to be used. Format is in YYYY-MM-DD.
      name: x-api-version
      in: header
      required: true
      schema:
        type: string
        default: '2025-11-01'
        example: '2025-11-01'
      example: '2025-11-01'
  schemas:
    CreateBeneResponse:
      type: object
      properties:
        bene_id:
          type: string
          description: >-
            Unique identifier for the beneficiary, as provided by you during
            beneficiary creation.
          example: BENE28448
        cf_bene_id:
          type: string
          description: Cashfree-generated unique ID for the beneficiary.
          example: '473974924929'
        user_id:
          type: string
          description: >-
            Unique identifier for the user, as provided by you during PPI user
            creation.
          example: USER827364
        bene_first_name:
          type: string
          description: First name of the beneficiary.
          example: John
        bene_last_name:
          type: string
          description: Last name of the beneficiary.
          example: Doe
        status:
          type: string
          description: Status of the beneficiary.
          example: ACTIVE
        bene_instruments:
          type: array
          description: List of payment `bene_instruments` for the beneficiary.
          items:
            oneOf:
              - title: Bank Account
                type: object
                properties:
                  bene_instrument_id:
                    type: string
                    description: >-
                      Unique identifier for the instrument, as provided by you
                      during beneficiary creation.
                    example: INST194947
                  type:
                    type: string
                    description: Type of instrument.
                    example: BANK_ACCOUNT
                  bank_bank_account_number:
                    type: string
                    description: Masked bank account number.
                    example: '3749378903'
                  ifsc:
                    type: string
                    description: IFSC code of the bank branch.
                    example: HDFC0001234
                  status:
                    type: string
                    description: >
                      Status of the instrument. Supported values:

                      - ACTIVE : The instrument is authorised to perform
                      transactions.

                      - INACTIVE : The instrument is not authorised to perform
                      transactions.

                      - INVALID : Beneficiary Instrument is invalid.

                      - BLOCKED : The instrument is restricted from performing
                      any transactions.
                  verification_status:
                    type: string
                    description: >
                      Verification status of the instrument. Supported values:

                      - PENDING : The verification is currently is pending.

                      - VERIFIED : The instrument has been successfully
                      verified.

                      - FAILED : The verification has failed.
                  cf_bene_instrument_id:
                    type: string
                    description: Cashfree-generated unique ID for the instrument.
                    example: '8324782642946'
              - title: VPA
                type: object
                properties:
                  bene_instrument_id:
                    type: string
                    description: >-
                      Unique identifier for the instrument, as provided by you
                      during beneficiary creation.
                    example: INST194947
                  type:
                    type: string
                    description: Type of instrument.
                    example: VPA
                  vpa:
                    type: string
                    description: Virtual Payment Address (UPI ID).
                    example: example@upi
                  status:
                    type: string
                    description: >
                      Status of the instrument. Supported values:

                      - ACTIVE : The instrument is authorised to perform
                      transactions.

                      - INACTIVE : The instrument is not authorised to perform
                      transactions.

                      - INVALID : The instrument is invalid.

                      - BLOCKED : The instrument is restricted from performing
                      any transactions.
                  verification_status:
                    type: string
                    description: >
                      Verification status of the instrument. Supported values:

                      - INITIATED : The verification is currently is initiated..

                      - VERIFIED : The instrument has been successfully
                      verified.

                      - FAILED : The verification has failed.
                  cf_bene_instrument_id:
                    type: string
                    description: Cashfree-generated unique ID for the instrument.
                    example: '8324782642946'
        bene_contact_details:
          type: object
          description: >-
            Contact details of the beneficiary. Only not null fields will be
            returned.
          properties:
            email:
              type: string
              description: Email address of the beneficiary.
              example: john.doe@example.com
            phone:
              type: string
              description: Phone number of the beneficiary.
              example: '9876543210'
            dob:
              type: string
              format: date
              description: Date of birth in YYYY-MM-DD format.
              example: '1990-05-12'
            gender:
              type: string
              enum:
                - MALE
                - FEMALE
                - OTHERS
              description: Gender of the beneficiary.
              example: MALE
            address:
              type: string
              description: Street address of the beneficiary.
              example: No. 123, 5th Main, Indiranagar
            city:
              type: string
              description: City of the beneficiary.
              example: Bangalore
            state:
              type: string
              description: State of the beneficiary.
              example: Karnataka
            pincode:
              type: string
              description: Pincode or ZIP code.
              example: '560038'
            country:
              type: string
              description: Country.
              example: India
        purpose:
          type: string
          example: Family
        notes:
          $ref: '#/components/schemas/Notes'
    StructuredErrorResponse:
      type: object
      properties:
        type:
          type: string
          description: A broad category of the error.
          example: internal_error
        code:
          type: string
          description: A machine-readable error code specific to the issue.
          example: internal_server_error
        message:
          type: string
          description: >-
            A message providing more details about the error, dynamic based on
            the specific issue.
          example: Internal server error
    Notes:
      type: object
      description: >-
        Optional key-value pairs for any extra information. Keys and values must
        be strings.
      properties:
        example_key:
          type: string
          description: value of the note
          example: example_value
  responses:
    Response401:
      description: Unauthorised - Invalid or missing authentication.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/StructuredErrorResponse'
          examples:
            invalidCredentials:
              summary: Invalid client credentials
              value:
                code: authentication_failed
                type: authentication_error
                message: Invalid client ID and client secret combination
    Response403:
      description: Forbidden - Access denied.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/StructuredErrorResponse'
          examples:
            ipNotWhitelisted:
              summary: IP not whitelisted
              value:
                code: ip_not_whitelisted
                type: authentication_error
                message: Authentication error (IP not whitelisted)
    Response429:
      description: Too Many Requests - Rate limit exceeded.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/StructuredErrorResponse'
          examples:
            internalError:
              summary: Internal server error
              value:
                code: too_many_requests_per_operation
                type: rate_limit_error
                message: Rate limit exceeded. Please try again after some time
    Response500:
      description: Internal server error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/StructuredErrorResponse'
          examples:
            internalError:
              summary: Internal server error
              value:
                code: internal_server_error
                type: internal_error
                message: An internal error occurred while processing the request
  securitySchemes:
    XClientID:
      type: apiKey
      in: header
      name: x-client-id
      description: >-
        Your unique client identifier issued by Cashfree. You can find this in
        your [Merchant
        Dashboard](https://merchant.cashfree.com/merchants/landing?env=prod).
    XClientSecret:
      type: apiKey
      in: header
      name: x-client-secret
      description: >-
        The secret key associated with your client ID. Use this to authenticate
        your API requests. You can find this in your [Merchant
        Dashboard](https://merchant.cashfree.com/merchants/landing?env=prod).

````